function [x,t] = EulerImplicit(MyFunc,InitialValue,Start,Finish,Nsteps)
% solves the initial value problem dx/dt = f(x)
% Uses the Euler (implicit) method
% Myfunc = Handle to the function which calculates F(x)
% InitialValue = starting value
% Start = start time
% finish = end time
% Nsteps = number of steps to march forward
x(:,1) = InitialValue;
t(1) = Start;
%calculate the time ste
dt = (Finish-Start)/Nsteps;
for i = 1:Nsteps
%solve the implicit equation to get the updated value of x
%calculate the new value of x and t
t(i+1) = dt + t(i);
x(:,i+1) = fsolve(@funToSolve,x(:,i),[],x(:,i),t(i+1),MyFunc,dt);
end
t = t';
x = x';
return